# CHANGELOG

binary-tools: JavaScript binary tools for any browser or environment.  
Copyright (c) 2023  Rafael da Silva Rocha.  
https://rochars.com/binary-tools

## 1.4.1
- Fix: when packing UTF-8 strings, throw 'Invalid UTF-8 character' error on
  packing code points in the range U+D800..U+DFFF instead of using replacement
  characters, according to the latest version (as of August 2023) of the
  Unicode Standard, chapter 3, section 3.9:
  https://www.unicode.org/versions/Unicode15.0.0/ch03.pdf

## 1.4.0
- New feature: type 'A' for unsigned 128-bit integers.
- New feature: type 'Y' for unsigned 256-bit integers.

## 1.3.0
- New feature: types 'q' and 'Q' for signed and unsigned 64-bit integers.

## 1.2.1
- ES6 dist file in ./index.js

## 1.2.0
- New feature: pack and unpack UTF-8 strings with type 'u'

## 1.1.0
- New feature: pack and unpack ASCII and ISO-8859-1 characters with
  types 'c' and 'C', respectively
- New feature: pack and unpack ASCII and ISO-8859-1 strings with
  types 's' and 'S', respectively

## 1.0.4
- Fix: includePads param default to false in calcSize() to keep
  1.x interface.

## 1.0.3
- Fix: calcSize() for format strings with padding bytes

## 1.0.2
- Fix: Signed user-defined integers with bit lengths that are
  not multiple of 8 now work properly.
- Fix: Correctly checking for overflows when reading/unpacking
  used-defined types with bit lengths that are not multiple of
  8 (5-bit ints, 12-bit ints and so). The previous behaviour
  was to incorrectly clamp the results on overflow. The expected
  behaviour is to throw a RangeError and inform the start index
  of the incorrect value on the buffer.

## 1.0.1
- Fix: unpackTo() was not validating the input buffer length
  when 'safe' was set to true.
- Fix: unpack() was not validating the input buffer length
  when 'safe' was set to true.
- Fix: unpack() was reading NaN when input buffer didnt had
  enough bytes (size too small or index too high) and 'safe'
  was false. Now it ignores the unreadable bytes according to
  each type, like stated in the docs.
- Fix: unpackTo() was reading NaN when input buffer didnt had
  enough bytes (size too small or index too high) and 'safe'
  was false. Now it ignores the unreadable bytes according to
  each type, like stated in the docs.
- Fix: writeTo() was not validating output buffer size if
  output was a TypedArray. Now it throws a Bad buffer length
  error when output is TypedArray and size is not enough.

## 1.0.0
